Option Explicit
' Called by Directory Opus to initialize the script
Function OnInit(ByRef initData)

   DOpus.Output("Initializing...")
   ' Provide basic information about the Script
   initData.name = "ScriptCommand_vbtest"
   initData.desc = "Adds the 'VBtest' command to Directory Opus."
   initData.copyright = "(c) 2014 steje"
   initData.version = "v1.0.0 (vb)"
   initData.default_enable = True

   ' Initialise the command that this script adds
   Dim cmd
   Set cmd = initData.AddCommand()
   cmd.name = "VBtest"
   cmd.icon = "script"
   cmd.method = "OnVBtest"
   cmd.desc = "VBtest - a test script for checking my slop code..."
   cmd.label = "VBtest"
   cmd.template = "STRING/O"

   '////////////////////////////////////////////////
   ' Set DEBUG flag below to true in order to enable logging messages to the Opus Output Window
   initData.config.DEBUG = True
   '////////////////////////////////////////////////
   ' Create a ScriptConfig property of type VT_BSTR
   initData.config.strScriptVT_BSTR = "VT_BSTR"
   '////////////////////////////////////////////////
   ' Create a ScriptConfig property of type VT_I4
   initData.config.iScriptVT_I4 = 255
   '////////////////////////////////////////////////
   ' Create a ScriptConfig property of type VT_BOOL
   initData.config.bScriptVT_BOOL = False
   '////////////////////////////////////////////////
   ' Create a ScriptConfig property of type VT_ARRAY / VB TypeName() will return type : Variant
   initData.config.objScriptVT_ARRAY = Array("First","Second","Third")

End Function


' Implement the VBtest command
Function OnVBtest(ByRef commandData)

   Dim message
   message = ""
   Const vbQuote = """"
   Dim STRING
   STRING = "VT_BSTR"

   logMsg("")
   logMsg("------------Begin------------")

   '////////////////////////////////////////////////
   ' Test the strScriptVT_BSTR ScriptConfig property
'   logMsg("")
'   message = "ScriptConfig property strScriptVT_BSTR is "
'   logMsg(message & "of type:  " & (TypeName(Script.config.strScriptVT_BSTR)))
'   If Not (StrComp(Script.config.strScriptVT_BSTR, STRING, vbTextCompare)) Then
'      logMsg(message & "set to:  DEFAULT -> " & Script.config.strScriptVT_BSTR)
'   Else
'      logMsg(message & "set to:  CUSTOM -> " & Script.config.strScriptVT_BSTR)
'   End If

   '////////////////////////////////////////////////
   ' Test the iScriptVT_I4 ScriptConfig property
'   logMsg("")
'   message = "ScriptConfig property iScriptVT_I4 is "
'   logMsg(message & "of type:  " & (TypeName(Script.config.iScriptVT_I4)))
'   If (Script.config.iScriptVT_I4 = 255) Then
'      logMsg(message & "set to:  DEFAULT -> " & Script.config.iScriptVT_I4)
'   Else
'      logMsg(message & "set to:  CUSTOM -> " & Script.config.iScriptVT_I4)
'   End If

   '////////////////////////////////////////////////
   ' Test the bScriptVT_BOOL ScriptConfig property
'   logMsg("")
'   message = "ScriptConfig property bScriptVT_BOOL is "
'   logMsg(message & "of type:  " & (TypeName(Script.config.bScriptVT_BOOL)))
'   If (Script.config.bScriptVT_BOOL = False) Then
'      logMsg(message & "set to:  DEFAULT -> " & Script.config.bScriptVT_BOOL)
'   Else
'      logMsg(message & "set to:  CUSTOM -> " & Script.config.bScriptVT_BOOL)
'   End If

   '////////////////////////////////////////////////
   ' Test the objScriptVT_ARRAY ScriptConfig property
   Dim i, x, objScriptVT_ARRAY_type, objLinkedTabList_type
   logMsg("")
   message = "ScriptConfig property objScriptVT_ARRAY "
   objScriptVT_ARRAY_type = TypeName(Script.config.objScriptVT_ARRAY)
   logMsg(message & "is of type:  " & objScriptVT_ARRAY_type)
   If Not (objScriptVT_ARRAY_type = "unknown") Then
      i = 0
      For Each x in (Script.config.objScriptVT_ARRAY)
         logMsg(message & "values are set to:  [" & i & "]: " & x)
         i = i + 1
      Next
   End If


   '////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   '////////////////////////////////////////////////
   ' Do 'other' stuff...

   '////////////////////////////////////////////////
   ' Command stuff
   Dim strPath, strCommand
   strPath = "C:\\temp"
   strCommand = "Go " & vbQuote & "C:\temp" & vbQuote & " NEWTAB OPENINDUAL"
   logMsg("")
   logMsg("------------Command stuff------------")
   logMsg(strCommand)
   'commandData.func.command.RunCommand("Go C:\\temp NEWTAB OPENINDUAL")
   commandData.func.command.RunCommand(strCommand)

   '////////////////////////////////////////////////
   ' Array function stuff
   logMsg("")
   logMsg("------------Array function stuff------------")
   logMsg("Size of objScriptVT_ARRAY property:  " & UBound(Script.config.objScriptVT_ARRAY))

   '////////////////////////////////////////////////
   ' Audio metadata stuff
   Dim objCmd
   Set objCmd = DOpus.CreateCommand
   logMsg("")
   logMsg("------------Audio metadata stuff------------")
   For Each x in commandData.func.sourcetab.files
      logMsg("Filename:    " & x.name)
      logMsg("Artist:      " & x.metadata.audio.mp3artist)
      logMsg("Album:       " & x.metadata.audio.mp3album)
      logMsg("Track:       " & x.metadata.audio.mp3track)
      logMsg("Title:       " & x.metadata.audio.mp3title)
      logMsg("Track Text:  " & x.metadata.audio_text.mp3track)
   Next

   '////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   logMsg("")
   logMsg("------------End------------" & vbCrLf)

End Function


' Subroutine to allow toggling of the global VT_BOOL variable to control whether logging is performed or not
Sub logMsg(message)

   If (Script.config.DEBUG) Then DOpus.Output(message)

End Sub
